您的位置:首页 > 编程语言 > C语言/C++

hdu-1394Minimum Inversion Number(暴力解法或者线段树 求最少逆序对)

2016-08-26 11:32 253 查看


Minimum Inversion Number

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)

Total Submission(s): 18319    Accepted Submission(s): 11123


Problem Description

The inversion number of a given number sequence a1, a2, ..., an is the number of pairs (ai, aj) that satisfy i < j and ai > aj.

For a given sequence of numbers a1, a2, ..., an, if we move the first m >= 0 numbers to the end of the seqence, we will obtain another sequence. There are totally n such sequences as the following:

a1, a2, ..., an-1, an (where m = 0 - the initial seqence)

a2, a3, ..., an, a1 (where m = 1)

a3, a4, ..., an, a1, a2 (where m = 2)

...

an, a1, a2, ..., an-1 (where m = n-1)

You are asked to write a program to find the minimum inversion number out of the above sequences.

 

Input

The input consists of a number of test cases. Each case consists of two lines: the first line contains a positive integer n (n <= 5000); the next line contains a permutation of the n integers from 0 to n-1.

 

Output

For each case, output the minimum inversion number on a single line.

 

Sample Input

10
1 3 6 9 0 8 5 7 4 2

 

Sample Output

16

 

Author

CHEN, Gaoli

 

Source

ZOJ Monthly, January 2003

 

Recommend

Ignatius.L   |   We have carefully selected several similar problems for you:  1540 1542 1255 1828 2871 

暴力解法

#include<iostream>
#include<string>
#include<cstring>
#include<cstdio>
using namespace std;
int a[5500];
int n;
int main()
{
while(~scanf("%d",&n))  //总共最多有n-1种逆数对
{
for(int i=0;i<n;i++)
{
scanf("%d",&a[i]);
}
int ans=0;
for(int i=0;i<n;i++)//求最开始的逆数对有多少
{
for(int j=i+1;j<n;j++)
{
if(a[i]>a[j])
ans++;
}
}
int res=999999999;
if(ans<res)res=ans;
for(int i=0;i<n;i++)
{
ans=ans-a[i]+n-1-a[i];//如果将a[i]移置最后 那么逆数对将减少a[i]中  但是反之会增加n-1-a[i]种逆数对
if(ans<res)res=ans;
}
printf("%d\n",res);
}
return 0;
}

/*
10
1 3 6 9 0 8 5 7 4 2

16
*/


线段树解法

#include<iostream>
#include<string>
#include<cstring>
#include<cstdio>
using namespace std;
#define N 5555
#define lson l,m,rt<<1
#define rson m+1,r,rt<<1|1
int sum[N<<2];
void pushup(int rt)
{
sum[rt]=sum[rt<<1]+sum[rt<<1|1];
}
void build(int l,int r,int rt)//初始化
{
sum[rt]=0;
if(l==r)
{
return;
}
int m=(l+r)>>1;
build(lson);
build(rson);
pushup(rt);
}
void update(int p,int l,int r,int rt)
{
if(l==r)
{
sum[rt]++;//由于存入了p这个点 sum[rt]的数量要加一  在递归更新节点的sum值
return ;
}
int m=(l+r)>>1;
if(p<=m)update(p,lson);
else update(p,rson);
pushup(rt);
}
int query(int L,int R,int l,int r,int rt)//将L到R之间有多少点存在的数量 求出来
{
if(L<=l&&R>=r)
{
return sum[rt];
}
int m=(l+r)>>1;
int res=0;
if(L<=m)res+=query(L,R,lson);
if(R>m)res+=query(L,R,rson);
return res;
}
int x
;
int main()
{
int n;
while(~scanf("%d",&n))
{
build(0,n-1,1);
int sum=0;
for(int i=0;i<n;i++)
{
scanf("%d",&x[i]);
sum+=query(x[i],n-1,0,n-1,1);//逆序对 当插入x[i]时 查找x[i]到n-1的区间有多少之前已经存入的点  有多少个即说明增加了多少个逆序对
update(x[i],0,n-1,1);//将x[i]数据更新到线段树中
}
int res=sum;
for(int i=0;i<n;i++)
{
sum=sum-x[i]+n-1-x[i];////如果将a[i]移置最后 那么逆数对将减少a[i]中  但是反之会增加n-1-a[i]种逆数对 循环一遍 查找最小逆序对的数量
res=min(sum,res);
}
cout<<res<<endl;
}
return 0;
}

/*
10
1 3 6 9 0 8 5 7 4 2

16
*/


 
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签:  c++ hdu 线段树